using System.Text;

namespace orchestrator_ui
{
    public partial class MainUI : Form
    {

        private string FileName;

        public MainUI()
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.ShowDialog();
            FileName = openFileDialog.FileName;
            if (!FileName.EndsWith(".settings"))
            {
                MessageBox.Show("Error! Only .settings file can be loaded");
                Application.Exit();
                return;
            }

            string[] lines = File.ReadAllLines(FileName);

            InitializeComponent();

            foreach (string line in lines)
            {
                listView1.Items.Add(line);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            bool isLiteral = literalBox.Checked;
            String entry = entryName.Text;
            String destination = destinationBox.Text;
            String source = sourceBox.Text;
            String mode = modeBox.Text;
            String extra = extraBox.Text;

            StringBuilder stringBuilder = new StringBuilder();
            if (isLiteral)
            {
                stringBuilder.Append("LITERAL ");
            }

            stringBuilder.Append(entry).Append(",").Append(destination).Append(",").Append(source).Append(",").Append(mode);

            if (extra.Trim().Length > 0)
            {
                stringBuilder.Append(" ").Append(extra);
            }

            listView1.Items.Add(stringBuilder.ToString());
        }

        private void saveButton_Click(object sender, EventArgs e)
        {
            List<String> list = new List<String>();
            foreach (ListViewItem item in listView1.Items) {
                list.Add(item.Text);
            }
            File.WriteAllLines(FileName, list.ToArray());
        }
    }
}
